default:
  tags: [shell, x86_64]

stages:
  - build
  - test
  - release

variables:
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:ci_test
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest

before_script:
  - podman login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

build:
  stage: build
  script:
    - podman build --pull -t $CONTAINER_TEST_IMAGE .
    - podman push $CONTAINER_TEST_IMAGE

test-get-version:
  stage: test
  script:
    - podman pull $CONTAINER_TEST_IMAGE
    - ./ci/get_version.sh "$CONTAINER_TEST_IMAGE" 1> build.env
  artifacts:
    reports:
      dotenv: build.env

release-image:
  stage: release
  script:
    - podman pull $CONTAINER_TEST_IMAGE
    - podman tag $CONTAINER_TEST_IMAGE $CI_REGISTRY_IMAGE:latest
    - podman push $CI_REGISTRY_IMAGE:latest
    - podman tag $CONTAINER_TEST_IMAGE $CI_REGISTRY_IMAGE:$CONTAINER_EXE_VERSION
    - podman push $CI_REGISTRY_IMAGE:$CONTAINER_EXE_VERSION
    - podman tag $CONTAINER_TEST_IMAGE $CI_REGISTRY_IMAGE:$CONTAINER_BUILD_DATE-$CONTAINER_EXE_VERSION
    - podman push $CI_REGISTRY_IMAGE:$CONTAINER_BUILD_DATE-$CONTAINER_EXE_VERSION
  only:
    - main
  needs:
    - test-get-version

